# TODO:
functionality:
- add help message that works everywhere (prints github repo)
- Create webhook, send flag

- (easy) Add hidden channel -> is this going to be easy?
- (medium) Add functionality that allows for channels to be backed up/exported w/ admin account (user role names + channel role names)
- (hard) recover message

# Bot
The *unofficial* StudSec bot written in Python using [discord.py](https://discordpy.readthedocs.io/en/stable/).

[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)

## Installation and Usage
To install the needed dependencies, first make sure you have [Poetry](https://python-poetry.org/docs/#installation)
 installed. After which, you can install the dependencies using

```sh
poetry install
```

Then, to run the bot needs a discord token, which needs to be put in a new 
 `.env` file like so

```
DISCORD_TOKEN=your_token_here
```

After the discord token is set, you can run the bot using

```sh
poetry run bot
```

## Development
The recommended development environment to develop in is using a python venv.
 You can enter one provided by poetry using

```sh
poetry shell
```

on top of this, this project (tries to) adhere to the google python style, and
 uses pylint for its linting and black for its styling. To do this simply enter
 a poetry shell and run
 ```sh
 pylint bot
 ```

## Documentation
To add a cog, use the following template

```py
"""
Module description
"""

from discord.ext import commands
from discord import app_commands
from discord.ext.commands import Context


class YourClassName(commands.Cog, name="yourClassName"):
    def __init__(self, bot) -> None:
        self.bot = bot

    # NOTE: this is for a command, non command cogs won't need this
    @app_commands.command(
        name="yourCommandName",
        description="The description of my command",
    )
    async def yourcommandhere(self, context: Context) -> None:
        """The description of my command

        :param context: The application command context.
        """
        return


async def setup(bot) -> None:  # pylint: disable=missing-function-docstring
    await bot.add_cog(YourClassName(bot))
```
